<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import PropertyCardInline from "./PropertyCardInline.svelte";
  import Cash from "./Cash.svelte";
  const dispatch = createEventDispatcher();
  function dispatchAction(action: Action): void {
    dispatch("action", action);
  }

  export let phase: BuyingPhase;
  export let players: Player[];
  export let user: Player;

  $: leadingBid = Math.max(...Object.values(phase.bids));

  let bid: number = 1000;
  $: {
    bid = bid - (bid % 1000);
    bid = Math.max(bid, minBid);
    bid = Math.min(bid, maxBid);
  }

  let minBid: number;
  $: {
    const userBid = getPlayerBid(user.id);
    minBid = Math.max(0, userBid, leadingBid) + 1000;
  }

  /** Maximum bid possible by current user */
  let maxBid: number;
  $: if (user !== undefined) {
    maxBid = user.cash;
  } else if (players.length < 5) {
    maxBid = 18000;
  } else {
    maxBid = 14000;
  }

  function getPlayerBid(playerId: PlayerId): number {
    if (phase.name === "buying") {
      return phase.bids[playerId] ?? 0;
    } else {
      return NaN;
    }
  }
</script>

<div class="wrapper">
  <div>
    Bid for house
    <PropertyCardInline card={Math.max(...phase.properties)} />
  </div>
  <div>
    <button
      type="button"
      class="secondary adjust-bid-button"
      disabled={bid <= minBid}
      on:click={() => {
        bid -= 1000;
      }}>−</button
    >
    <Cash cash={bid} />
    <button
      type="button"
      class="secondary adjust-bid-button"
      disabled={bid >= maxBid}
      on:click={() => {
        bid += 1000;
      }}>+</button
    >
  </div>
  <button
    class="primary"
    disabled={bid <= leadingBid}
    on:click={() => {
      dispatchAction({ name: "bid", cash: bid });
    }}>Place bid</button
  >
</div>

<style>
  .wrapper {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    gap: 0.125em;
  }
  .adjust-bid-button {
    border-radius: 50%;
    width: 2rem;
    height: 2rem;
    padding: 0;
    transform: translateY(-0.125em);
  }
</style>
